#! /usr/bin/env perl

use File::Copy;

my $fpatt = "job_dagman_*.run";
my $dagargs = '(\$dagman_args\s*=\s*".*)("\s*;)';
my $fcount = 0;

# scan the dir for our run files
$dir = '.';
@files = grep{-f $_}glob("$dir/$fpatt");

# open each and read the lines
foreach (@files) {
	# backup the original
	$bk_file = $_.".backup";
    	die "$_ already backed up to $bk_file" if ( -e $bk_file );
    	copy($_, $bk_file) || die "$_ could not be backed up, copy failed";
	$fcount++;
	open (DAGBK,$bk_file) || die "Unable to open $_";
	open (DAGRUN,">$_") || die "Unable to open $_";
	while (<DAGBK>) {
		# match on our dag args
		if (/$dagargs/) {
			print DAGRUN "$1 ",join(' ',@ARGV),"$2";
		}
		else {
			print DAGRUN $_;
		}
	}
	close DAGRUN;
	close DAGBK;
}

print "Backed up $fcount files\n";
# insert the args provided
